/*
 * funkcje.c
 *
 *  Created on: 28 mar 2017
 *      Author: Mateusz Kuc
 *      Email: kucmateusz92@gmail.com
 */

#include "stm32f0xx_hal.h"
#include "adc.h"
#include "spi.h"
#include "tim.h"
#include "gpio.h"
#include "NRF24L01.h"
#include "DHT11.h"
#include "funkcje.h"
#include "plik_sterujacy.h"

void temperatura_wilgotnosc(void)
{
	HAL_Delay(100);
	uint8_t checksuma=1;
	uint8_t dht11[6]={0,0,0,0,0,0};
	DHT11(dht11);
	data[1]=(dht11[0]+dht11[1]);
	data[2]=(dht11[2]+dht11[3]);
	checksuma=data[1]+data[2];
	if(dht11[4]==checksuma && data[1]<100 && data[2]<100)
		data[3]=1;
	else
		data[3]=0;
	wyslij_dane(data, ((sizeof data)/(sizeof *data)), ACK);
	while(jest_wysylane());
	data[0]=0;
	tryb_RX();
}

void wilgotnosc_gleby(void)
{
	HAL_Delay(100);
	data[1]=0;
	data[2]=0;
	data[3]=1;
	data[4]=0;
	HAL_ADC_Start(&hadc);
	HAL_Delay(1);
	if (HAL_ADC_PollForConversion(&hadc, 10) == HAL_OK)
		 data[1] = HAL_ADC_GetValue(&hadc);
	data[1] = data[1] - 105;
	if(data[1]<100 && data[1]>0)
		data[1] = 100 - data[1];
	if(data[1]>100)
		data[1]=100;

	wyslij_dane(data, ((sizeof data)/(sizeof *data)), ACK);
	while(jest_wysylane());
	data[0]=0;
	tryb_RX();
}

void okno_drzwi_ruch(uint8_t numer_czujnika)
{
	//numer 1 - kontaktron
	//numer 2 - czujnik ruchu PIR
		data[2]=0;
		data[3]=1;
		data[4]=0;
#if kontaktron_aktywne == 1
		if(numer_czujnika==1)
		{
			if(HAL_GPIO_ReadPin(KONTAKTRON_GPIO_Port, KONTAKTRON_Pin )== GPIO_PIN_RESET)
			{
				data[1]=1;
			}
			else if(HAL_GPIO_ReadPin(KONTAKTRON_GPIO_Port, KONTAKTRON_Pin) == GPIO_PIN_SET)
			{
				data[1]=0;
			}
			else
			{
				data[1]=2;//oznacza blad
			}
		}
#endif

#if czujnik_ruchu_aktywne == 1
		if(numer_czujnika==2)
		{
			if(HAL_GPIO_ReadPin(PIR_GPIO_Port, PIR_Pin )== GPIO_PIN_RESET)
			{
				data[1]=0;
			}
			else if(HAL_GPIO_ReadPin(PIR_GPIO_Port, PIR_Pin) == GPIO_PIN_SET)
			{
				data[1]=1;
			}
			else
			{
				data[1]=2;//oznacza blad
			}
		}
#endif

		wyslij_dane(data, ((sizeof data)/(sizeof *data)), ACK);
		while(jest_wysylane());
		data[0]=0;
		tryb_RX();
}
